
// ==UserScript==
// @name           Simple YouTube Age Restriction Bypass
// @description    Watch age restricted videos on YouTube without login and without age verification :)
// @description:de Schaue YouTube Videos mit Altersbeschränkungen ohne Anmeldung und ohne dein Alter zu bestätigen :)
// @description:fr Regardez des vidéos YouTube avec des restrictions d'âge sans vous inscrire et sans confirmer votre âge :)
// @description:it Guarda i video con restrizioni di età su YouTube senza login e senza verifica dell'età :)
// @version        2.1.4
// @author         Zerody (https://github.com/zerodytrash)
// @namespace      https://github.com/zerodytrash/Simple-YouTube-Age-Restriction-Bypass/
// @updateURL      https://github.com/zerodytrash/Simple-YouTube-Age-Restriction-Bypass/raw/main/Simple-YouTube-Age-Restriction-Bypass.user.js
// @downloadURL    https://github.com/zerodytrash/Simple-YouTube-Age-Restriction-Bypass/raw/main/Simple-YouTube-Age-Restriction-Bypass.user.js
// @supportURL     https://github.com/zerodytrash/Simple-YouTube-Age-Restriction-Bypass/issues
// @license        MIT
// @match          https://www.youtube.com/*
// @match          https://m.youtube.com/*
// @run-at         document-start
// @compatible     chrome Chrome + Tampermonkey or Violentmonkey
// @compatible     firefox Firefox + Greasemonkey or Tampermonkey or Violentmonkey
// @compatible     opera Opera + Tampermonkey or Violentmonkey
// @compatible     edge Edge + Tampermonkey or Violentmonkey
// @compatible     safari Safari + Tampermonkey or Violentmonkey
// @grant          GM_info
// @grant          none
// ==/UserScript==

(function () {

  function ownKeys(object, enumerableOnly) {
    var keys = Object.keys(object);

    if (Object.getOwnPropertySymbols) {
      var symbols = Object.getOwnPropertySymbols(object);

      if (enumerableOnly) {
        symbols = symbols.filter(function (sym) {
          return Object.getOwnPropertyDescriptor(object, sym).enumerable;
        });
      }

      keys.push.apply(keys, symbols);
    }

    return keys;
  }

  function _objectSpread2(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i] != null ? arguments[i] : {};

      if (i % 2) {
        ownKeys(Object(source), true).forEach(function (key) {
          _defineProperty(target, key, source[key]);
        });
      } else if (Object.getOwnPropertyDescriptors) {
        Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
      } else {
        ownKeys(Object(source)).forEach(function (key) {
          Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
        });
      }
    }

    return target;
  }

  function _typeof(obj) {
    "@babel/helpers - typeof";

    if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
      _typeof = function (obj) {
        return typeof obj;
      };
    } else {
      _typeof = function (obj) {
        return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
      };
    }

    return _typeof(obj);
  }

  function _defineProperty(obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, {
        value: value,
        enumerable: true,
        configurable: true,
        writable: true
      });
    } else {
      obj[key] = value;
    }

    return obj;
  }

  var initUnlocker = function initUnlocker() {
    var UNLOCKABLE_PLAYER_STATES = ["AGE_VERIFICATION_REQUIRED", "AGE_CHECK_REQUIRED", "LOGIN_REQUIRED"];
    var PLAYER_RESPONSE_ALIASES = ["ytInitialPlayerResponse", "playerResponse"]; // YouTube API config (Innertube).
    // The actual values will be determined later from the global ytcfg variable => setInnertubeConfigFromYtcfg()

    var INNERTUBE_CONFIG = {
      INNERTUBE_API_KEY: "AIzaSyAO_FJ2SlqU8Q4STEHLGCilw_Y9_11qcW8",
      INNERTUBE_CLIENT_NAME: "WEB",
      INNERTUBE_CLIENT_VERSION: "2.20210721.00.00",
      INNERTUBE_CONTEXT: {},
      STS: 18834,
      // signatureTimestamp (relevant for the cipher functions)
      LOGGED_IN: false
    }; // The following proxies are currently used as fallback if the innertube age-gate bypass doesn't work...
    // You can host your own account proxy instance. See https://github.com/zerodytrash/Simple-YouTube-Age-Restriction-Bypass/tree/main/account-proxy

    var ACCOUNT_PROXY_SERVER_HOST = "https://youtube-proxy.zerody.one";
    var VIDEO_PROXY_SERVER_HOST = "https://phx.4everproxy.com";
    var nativeParse = window.JSON.parse; // Backup the original parse function

    var nativeDefineProperty = getNativeDefineProperty(); // Backup the original defineProperty function to intercept setter & getter on the ytInitialPlayerResponse

    var nativeXmlHttpOpen = XMLHttpRequest.prototype.open; // Just for compatibility: Backup original getter/setter for 'ytInitialPlayerResponse', defined by other extensions like AdBlock

    var _ref = Object.getOwnPropertyDescriptor(window, "ytInitialPlayerResponse") || {},
        chainedPlayerGetter = _ref.get,
        chainedPlayerSetter = _ref.set;

    var wrappedPlayerResponse;
    var wrappedNextResponse;
    var lastProxiedGoogleVideoUrlParams;
    var responseCache = {};

    var Deferred = function Deferred() {
      var _this = this;

      return Object.assign(new Promise(function (resolve, reject) {
        _this.resolve = resolve;
        _this.reject = reject;
      }), this);
    };

    var Notification = function () {
      var isPolymer = !!window.Polymer;
      var pageLoad = new Deferred();
      var pageLoadEventName = isPolymer ? 'yt-navigate-finish' : 'state-navigateend';
      var node = isPolymer ? createElement('tp-yt-paper-toast') : createElement('c3-toast', {
        innerHTML: '<ytm-notification-action-renderer><div class="notification-action-response-text"></div></ytm-notification-action-renderer>'
      });
      var nMobileText = !isPolymer && node.querySelector('.notification-action-response-text');
      window.addEventListener(pageLoadEventName, init, {
        once: true
      });

      function init() {
        document.body.append(node);
        pageLoad.resolve();
      }

      function show(message) {
        var duration = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 5;
        pageLoad.then(_show);

        function _show() {
          if (isPolymer) {
            node.duration = duration * 1000;
            node.show(message);
          } else {
            nMobileText.innerHTML = message;
            node.setAttribute('dir', 'in');
            setTimeout(function () {
              node.setAttribute('dir', 'out');
            }, duration * 1000 + 225);
          }
        }
      }

      return {
        show: show
      };
    }(); // Just for compatibility: Intercept (re-)definitions on YouTube's initial player response property to chain setter/getter from other extensions by hijacking the Object.defineProperty function


    Object.defineProperty = function (obj, prop, descriptor) {
      if (obj === window && PLAYER_RESPONSE_ALIASES.includes(prop)) {
        console.info("Another extension tries to redefine '" + prop + "' (probably an AdBlock extension). Chain it...");
        if (descriptor !== null && descriptor !== void 0 && descriptor.set) chainedPlayerSetter = descriptor.set;
        if (descriptor !== null && descriptor !== void 0 && descriptor.get) chainedPlayerGetter = descriptor.get;
      } else {
        nativeDefineProperty(obj, prop, descriptor);
      }
    }; // Redefine 'ytInitialPlayerResponse' to inspect and modify the initial player response as soon as the variable is set on page load


    nativeDefineProperty(window, "ytInitialPlayerResponse", {
      set: function set(playerResponse) {
        // prevent recursive setter calls by ignoring unchanged data (this fixes a problem caused by Brave browser shield)
        if (playerResponse === wrappedPlayerResponse) return;
        wrappedPlayerResponse = inspectJsonData(playerResponse);
        if (typeof chainedPlayerSetter === "function") chainedPlayerSetter(wrappedPlayerResponse);
      },
      get: function get() {
        if (typeof chainedPlayerGetter === "function") try {
          return chainedPlayerGetter();
        } catch (err) {}
        return wrappedPlayerResponse || {};
      },
      configurable: true
    }); // Also redefine 'ytInitialData' for the initial next/sidebar response

    nativeDefineProperty(window, "ytInitialData", {
      set: function set(nextResponse) {
        wrappedNextResponse = inspectJsonData(nextResponse);
      },
      get: function get() {
        return wrappedNextResponse;
      },
      configurable: true
    }); // Intercept XMLHttpRequest.open to rewrite video URL's (sometimes required)

    XMLHttpRequest.prototype.open = function () {
      if (arguments.length > 1 && typeof arguments[1] === "string" && arguments[1].indexOf("https://") === 0) {
        // If the account proxy was used to retieve the video info, the following applies:
        // some video files (mostly music videos) can only be accessed from IPs in the same country as the innertube api request (/youtubei/v1/player) was made.
        // to get around this, the googlevideo URL will be replaced with a web-proxy URL in the same country (US).
        // this is only required if the "gcr=[countrycode]" flag is set in the googlevideo-url...
        var isGoogleVideo = function isGoogleVideo() {
          return method === "GET" && url.host.indexOf(".googlevideo.com") > 0;
        };

        var hasGcrFlag = function hasGcrFlag() {
          return urlParams.get("gcr") !== null;
        };

        var isUnlockedByAccountProxy = function isUnlockedByAccountProxy() {
          var _lastProxiedGoogleVid;

          return urlParams.get("id") !== null && urlParams.get("id") === ((_lastProxiedGoogleVid = lastProxiedGoogleVideoUrlParams) === null || _lastProxiedGoogleVid === void 0 ? void 0 : _lastProxiedGoogleVid.get("id"));
        };

        var method = arguments[0];
        var url = new URL(arguments[1]);
        var urlParams = new URLSearchParams(url.search);

        if (isGoogleVideo() && hasGcrFlag() && isUnlockedByAccountProxy()) {
          // rewrite request URL
          arguments[1] = VIDEO_PROXY_SERVER_HOST + "/direct/" + btoa(arguments[1]); // solve CORS errors by preventing YouTube from enabling the "withCredentials" option (not required for the proxy)

          nativeDefineProperty(this, "withCredentials", {
            set: function set() {},
            get: function get() {
              return false;
            }
          });
        }
      }

      return nativeXmlHttpOpen.apply(this, arguments);
    }; // Intercept, inspect and modify JSON-based communication to unlock player responses by hijacking the JSON.parse function


    window.JSON.parse = function (text, reviver) {
      return inspectJsonData(nativeParse(text, reviver));
    };

    function inspectJsonData(parsedData) {
      // If YouTube does JSON.parse(null) or similar weird things
      if (_typeof(parsedData) !== "object" || parsedData === null) return parsedData;

      try {
        var _parsedData$playerRes, _parsedData$playerRes2;

        // Unlock #1: Array based in "&pbj=1" AJAX response on any navigation (does not seem to be used anymore)
        if (Array.isArray(parsedData)) {
          var _ref2 = parsedData.find(function (e) {
            return _typeof(e.playerResponse) === "object";
          }) || {},
              playerResponse = _ref2.playerResponse;

          if (playerResponse && isAgeRestricted(playerResponse.playabilityStatus)) {
            playerResponseArrayItem.playerResponse = unlockPlayerResponse(playerResponse);

            var _ref3 = parsedData.find(function (e) {
              return _typeof(e.response) === "object";
            }) || {},
                nextResponse = _ref3.response;

            if (isWatchNextObject(nextResponse) && !isLoggedIn() && isWatchNextSidebarEmpty(nextResponse.contents)) {
              nextResponseArrayItem.response = unlockNextResponse(nextResponse);
            }
          }
        } // Unlock #2: Another JSON-Object containing the 'playerResponse' (seems to be used by m.youtube.com with &pbj=1)


        if ((_parsedData$playerRes = parsedData.playerResponse) !== null && _parsedData$playerRes !== void 0 && _parsedData$playerRes.playabilityStatus && (_parsedData$playerRes2 = parsedData.playerResponse) !== null && _parsedData$playerRes2 !== void 0 && _parsedData$playerRes2.videoDetails && isAgeRestricted(parsedData.playerResponse.playabilityStatus)) {
          parsedData.playerResponse = unlockPlayerResponse(parsedData.playerResponse);
        } // Unlock #3: Initial page data structure and response from the '/youtubei/v1/player' endpoint


        if (parsedData.playabilityStatus && parsedData.videoDetails && isAgeRestricted(parsedData.playabilityStatus)) {
          parsedData = unlockPlayerResponse(parsedData);
        } // Equivelant of unlock #2 for sidebar/next response


        if (isWatchNextObject(parsedData.response) && !isLoggedIn() && isWatchNextSidebarEmpty(parsedData.response.contents)) {
          parsedData.response = unlockNextResponse(parsedData.response);
        } // Equivelant of unlock #3 for sidebar/next response


        if (isWatchNextObject(parsedData) && !isLoggedIn() && isWatchNextSidebarEmpty(parsedData.contents)) {
          parsedData = unlockNextResponse(parsedData);
        }
      } catch (err) {
        console.error("Simple-YouTube-Age-Restriction-Bypass-Error:", err, "You can report bugs at: https://github.com/zerodytrash/Simple-YouTube-Age-Restriction-Bypass/issues");
      }

      return parsedData;
    }

    function isAgeRestricted(playabilityStatus) {
      if (!(playabilityStatus !== null && playabilityStatus !== void 0 && playabilityStatus.status)) return false;
      return !!playabilityStatus.desktopLegacyAgeGateReason || UNLOCKABLE_PLAYER_STATES.includes(playabilityStatus.status);
    }

    function isWatchNextObject(parsedData) {
      var _parsedData$currentVi, _parsedData$currentVi2;

      if (!(parsedData !== null && parsedData !== void 0 && parsedData.contents) || !(parsedData !== null && parsedData !== void 0 && (_parsedData$currentVi = parsedData.currentVideoEndpoint) !== null && _parsedData$currentVi !== void 0 && (_parsedData$currentVi2 = _parsedData$currentVi.watchEndpoint) !== null && _parsedData$currentVi2 !== void 0 && _parsedData$currentVi2.videoId)) return false;
      return !!parsedData.contents.twoColumnWatchNextResults || !!parsedData.contents.singleColumnWatchNextResults;
    }

    function isWatchNextSidebarEmpty(contents) {
      var _contents$twoColumnWa, _contents$twoColumnWa2, _contents$singleColum, _contents$singleColum2, _contents$singleColum3;

      var secondaryResults = (_contents$twoColumnWa = contents.twoColumnWatchNextResults) === null || _contents$twoColumnWa === void 0 ? void 0 : (_contents$twoColumnWa2 = _contents$twoColumnWa.secondaryResults) === null || _contents$twoColumnWa2 === void 0 ? void 0 : _contents$twoColumnWa2.secondaryResults;
      if (secondaryResults !== null && secondaryResults !== void 0 && secondaryResults.results) return false; // MWEB response layout

      var singleColumnWatchNextContents = (_contents$singleColum = contents.singleColumnWatchNextResults) === null || _contents$singleColum === void 0 ? void 0 : (_contents$singleColum2 = _contents$singleColum.results) === null || _contents$singleColum2 === void 0 ? void 0 : (_contents$singleColum3 = _contents$singleColum2.results) === null || _contents$singleColum3 === void 0 ? void 0 : _contents$singleColum3.contents;
      if (!singleColumnWatchNextContents) return true;

      var _ref4 = singleColumnWatchNextContents.find(function (e) {
        var _e$itemSectionRendere;

        return ((_e$itemSectionRendere = e.itemSectionRenderer) === null || _e$itemSectionRendere === void 0 ? void 0 : _e$itemSectionRendere.targetId) === "watch-next-feed";
      }) || {},
          itemSectionRenderer = _ref4.itemSectionRenderer;

      return !!itemSectionRenderer;
    }

    function isLoggedIn() {
      setInnertubeConfigFromYtcfg();
      return INNERTUBE_CONFIG.LOGGED_IN;
    }

    function unlockPlayerResponse(playerResponse) {
      var _playerResponse$playa, _unlockedPayerRespons, _unlockedPayerRespons4;

      var videoId = playerResponse.videoDetails.videoId;
      var reason = (_playerResponse$playa = playerResponse.playabilityStatus) === null || _playerResponse$playa === void 0 ? void 0 : _playerResponse$playa.status;
      var unlockedPayerResponse = getUnlockedPlayerResponse(videoId, reason); // account proxy error?

      if (unlockedPayerResponse.errorMessage) {
        Notification.show("Unable to unlock this video 🙁 - More information in the developer console (ProxyError)", 10);
        throw new Error("Unlock Failed, errorMessage:".concat(unlockedPayerResponse.errorMessage, "; innertubeApiKey:").concat(INNERTUBE_CONFIG.INNERTUBE_API_KEY, "; innertubeClientName:").concat(INNERTUBE_CONFIG.INNERTUBE_CLIENT_NAME, "; innertubeClientVersion:").concat(INNERTUBE_CONFIG.INNERTUBE_CLIENT_VERSION));
      } // check if the unlocked response isn't playable


      if (((_unlockedPayerRespons = unlockedPayerResponse.playabilityStatus) === null || _unlockedPayerRespons === void 0 ? void 0 : _unlockedPayerRespons.status) !== "OK") {
        var _unlockedPayerRespons2, _unlockedPayerRespons3;

        Notification.show("Unable to unlock this video \uD83D\uDE41 - More information in the developer console (playabilityStatus: ".concat((_unlockedPayerRespons2 = unlockedPayerResponse.playabilityStatus) === null || _unlockedPayerRespons2 === void 0 ? void 0 : _unlockedPayerRespons2.status, ")"), 10);
        throw new Error("Unlock Failed, playabilityStatus:".concat((_unlockedPayerRespons3 = unlockedPayerResponse.playabilityStatus) === null || _unlockedPayerRespons3 === void 0 ? void 0 : _unlockedPayerRespons3.status, "; innertubeApiKey:").concat(INNERTUBE_CONFIG.INNERTUBE_API_KEY, "; innertubeClientName:").concat(INNERTUBE_CONFIG.INNERTUBE_CLIENT_NAME, "; innertubeClientVersion:").concat(INNERTUBE_CONFIG.INNERTUBE_CLIENT_VERSION));
      } // if the video info was retrieved via proxy, store the URL params from the url- or signatureCipher-attribute to detect later if the requested video files are from this unlock.
      // => see isUnlockedByAccountProxy()


      if (unlockedPayerResponse.proxied && (_unlockedPayerRespons4 = unlockedPayerResponse.streamingData) !== null && _unlockedPayerRespons4 !== void 0 && _unlockedPayerRespons4.adaptiveFormats) {
        var _unlockedPayerRespons5, _unlockedPayerRespons6;

        var cipherText = (_unlockedPayerRespons5 = unlockedPayerResponse.streamingData.adaptiveFormats.find(function (x) {
          return x.signatureCipher;
        })) === null || _unlockedPayerRespons5 === void 0 ? void 0 : _unlockedPayerRespons5.signatureCipher;
        var videoUrl = cipherText ? new URLSearchParams(cipherText).get("url") : (_unlockedPayerRespons6 = unlockedPayerResponse.streamingData.adaptiveFormats.find(function (x) {
          return x.url;
        })) === null || _unlockedPayerRespons6 === void 0 ? void 0 : _unlockedPayerRespons6.url;
        lastProxiedGoogleVideoUrlParams = videoUrl ? new URLSearchParams(new URL(videoUrl).search) : null;
      }

      Notification.show("Video successfully unlocked!");
      return unlockedPayerResponse;
    }

    function unlockNextResponse(nextResponse) {
      var _nextResponse$content, _nextResponse$content2, _nextResponse$content3, _nextResponse$content4, _nextResponse$content5, _nextResponse$content6, _nextResponse$content7, _nextResponse$content8, _nextResponse$content9, _nextResponse$content10, _nextResponse$content11, _nextResponse$content12, _unlockedNextResponse8, _unlockedNextResponse9, _unlockedNextResponse10, _unlockedNextResponse11, _unlockedNextResponse12, _unlockedNextResponse13, _nextResponse$engagem, _nextResponse$engagem2, _nextResponse$engagem3, _nextResponse$engagem4, _nextResponse$engagem5, _nextResponse$engagem6, _unlockedNextResponse14, _unlockedNextResponse15, _unlockedNextResponse16, _unlockedNextResponse17, _unlockedNextResponse18, _unlockedNextResponse19;

      var _nextResponse$current = nextResponse.currentVideoEndpoint.watchEndpoint,
          videoId = _nextResponse$current.videoId,
          playlistId = _nextResponse$current.playlistId,
          playlistIndex = _nextResponse$current.index;
      var unlockedNextResponse = getUnlockedNextResponse(videoId, playlistId, playlistIndex); // check if the unlocked response's sidebar is still empty

      if (isWatchNextSidebarEmpty(unlockedNextResponse.contents)) {
        throw new Error("Sidebar Unlock Failed, innertubeApiKey:".concat(INNERTUBE_CONFIG.INNERTUBE_API_KEY, "; innertubeClientName:").concat(INNERTUBE_CONFIG.INNERTUBE_CLIENT_NAME, "; innertubeClientVersion:").concat(INNERTUBE_CONFIG.INNERTUBE_CLIENT_VERSION));
      } // Transfer WatchNextResults to original response


      if ((_nextResponse$content = nextResponse.contents) !== null && _nextResponse$content !== void 0 && (_nextResponse$content2 = _nextResponse$content.twoColumnWatchNextResults) !== null && _nextResponse$content2 !== void 0 && _nextResponse$content2.secondaryResults) {
        var _unlockedNextResponse, _unlockedNextResponse2;

        nextResponse.contents.twoColumnWatchNextResults.secondaryResults = unlockedNextResponse === null || unlockedNextResponse === void 0 ? void 0 : (_unlockedNextResponse = unlockedNextResponse.contents) === null || _unlockedNextResponse === void 0 ? void 0 : (_unlockedNextResponse2 = _unlockedNextResponse.twoColumnWatchNextResults) === null || _unlockedNextResponse2 === void 0 ? void 0 : _unlockedNextResponse2.secondaryResults;
      } // Transfer mobile (MWEB) WatchNextResults to original response


      if ((_nextResponse$content3 = nextResponse.contents) !== null && _nextResponse$content3 !== void 0 && (_nextResponse$content4 = _nextResponse$content3.singleColumnWatchNextResults) !== null && _nextResponse$content4 !== void 0 && (_nextResponse$content5 = _nextResponse$content4.results) !== null && _nextResponse$content5 !== void 0 && (_nextResponse$content6 = _nextResponse$content5.results) !== null && _nextResponse$content6 !== void 0 && _nextResponse$content6.contents) {
        var _unlockedNextResponse3, _unlockedNextResponse4, _unlockedNextResponse5, _unlockedNextResponse6, _unlockedNextResponse7;

        var unlockedWatchNextFeed = unlockedNextResponse === null || unlockedNextResponse === void 0 ? void 0 : (_unlockedNextResponse3 = unlockedNextResponse.contents) === null || _unlockedNextResponse3 === void 0 ? void 0 : (_unlockedNextResponse4 = _unlockedNextResponse3.singleColumnWatchNextResults) === null || _unlockedNextResponse4 === void 0 ? void 0 : (_unlockedNextResponse5 = _unlockedNextResponse4.results) === null || _unlockedNextResponse5 === void 0 ? void 0 : (_unlockedNextResponse6 = _unlockedNextResponse5.results) === null || _unlockedNextResponse6 === void 0 ? void 0 : (_unlockedNextResponse7 = _unlockedNextResponse6.contents) === null || _unlockedNextResponse7 === void 0 ? void 0 : _unlockedNextResponse7.find(function (x) {
          var _x$itemSectionRendere;

          return ((_x$itemSectionRendere = x.itemSectionRenderer) === null || _x$itemSectionRendere === void 0 ? void 0 : _x$itemSectionRendere.targetId) === "watch-next-feed";
        });
        if (unlockedWatchNextFeed) nextResponse.contents.singleColumnWatchNextResults.results.results.contents.push(unlockedWatchNextFeed);
      } // Transfer video description to original response


      var originalVideoSecondaryInfoRenderer = (_nextResponse$content7 = nextResponse.contents) === null || _nextResponse$content7 === void 0 ? void 0 : (_nextResponse$content8 = _nextResponse$content7.twoColumnWatchNextResults) === null || _nextResponse$content8 === void 0 ? void 0 : (_nextResponse$content9 = _nextResponse$content8.results) === null || _nextResponse$content9 === void 0 ? void 0 : (_nextResponse$content10 = _nextResponse$content9.results) === null || _nextResponse$content10 === void 0 ? void 0 : (_nextResponse$content11 = _nextResponse$content10.contents) === null || _nextResponse$content11 === void 0 ? void 0 : (_nextResponse$content12 = _nextResponse$content11.find(function (x) {
        return x.videoSecondaryInfoRenderer;
      })) === null || _nextResponse$content12 === void 0 ? void 0 : _nextResponse$content12.videoSecondaryInfoRenderer;
      var unlockedVideoSecondaryInfoRenderer = (_unlockedNextResponse8 = unlockedNextResponse.contents) === null || _unlockedNextResponse8 === void 0 ? void 0 : (_unlockedNextResponse9 = _unlockedNextResponse8.twoColumnWatchNextResults) === null || _unlockedNextResponse9 === void 0 ? void 0 : (_unlockedNextResponse10 = _unlockedNextResponse9.results) === null || _unlockedNextResponse10 === void 0 ? void 0 : (_unlockedNextResponse11 = _unlockedNextResponse10.results) === null || _unlockedNextResponse11 === void 0 ? void 0 : (_unlockedNextResponse12 = _unlockedNextResponse11.contents) === null || _unlockedNextResponse12 === void 0 ? void 0 : (_unlockedNextResponse13 = _unlockedNextResponse12.find(function (x) {
        return x.videoSecondaryInfoRenderer;
      })) === null || _unlockedNextResponse13 === void 0 ? void 0 : _unlockedNextResponse13.videoSecondaryInfoRenderer;
      if (originalVideoSecondaryInfoRenderer && unlockedVideoSecondaryInfoRenderer !== null && unlockedVideoSecondaryInfoRenderer !== void 0 && unlockedVideoSecondaryInfoRenderer.description) originalVideoSecondaryInfoRenderer.description = unlockedVideoSecondaryInfoRenderer.description; // Transfer mobile (MWEB) video description to original response

      var originalStructuredDescriptionContentRenderer = (_nextResponse$engagem = nextResponse.engagementPanels) === null || _nextResponse$engagem === void 0 ? void 0 : (_nextResponse$engagem2 = _nextResponse$engagem.find(function (x) {
        return x.engagementPanelSectionListRenderer;
      })) === null || _nextResponse$engagem2 === void 0 ? void 0 : (_nextResponse$engagem3 = _nextResponse$engagem2.engagementPanelSectionListRenderer) === null || _nextResponse$engagem3 === void 0 ? void 0 : (_nextResponse$engagem4 = _nextResponse$engagem3.content) === null || _nextResponse$engagem4 === void 0 ? void 0 : (_nextResponse$engagem5 = _nextResponse$engagem4.structuredDescriptionContentRenderer) === null || _nextResponse$engagem5 === void 0 ? void 0 : (_nextResponse$engagem6 = _nextResponse$engagem5.items) === null || _nextResponse$engagem6 === void 0 ? void 0 : _nextResponse$engagem6.find(function (x) {
        return x.expandableVideoDescriptionBodyRenderer;
      });
      var unlockedStructuredDescriptionContentRenderer = (_unlockedNextResponse14 = unlockedNextResponse.engagementPanels) === null || _unlockedNextResponse14 === void 0 ? void 0 : (_unlockedNextResponse15 = _unlockedNextResponse14.find(function (x) {
        return x.engagementPanelSectionListRenderer;
      })) === null || _unlockedNextResponse15 === void 0 ? void 0 : (_unlockedNextResponse16 = _unlockedNextResponse15.engagementPanelSectionListRenderer) === null || _unlockedNextResponse16 === void 0 ? void 0 : (_unlockedNextResponse17 = _unlockedNextResponse16.content) === null || _unlockedNextResponse17 === void 0 ? void 0 : (_unlockedNextResponse18 = _unlockedNextResponse17.structuredDescriptionContentRenderer) === null || _unlockedNextResponse18 === void 0 ? void 0 : (_unlockedNextResponse19 = _unlockedNextResponse18.items) === null || _unlockedNextResponse19 === void 0 ? void 0 : _unlockedNextResponse19.find(function (x) {
        return x.expandableVideoDescriptionBodyRenderer;
      });
      if (originalStructuredDescriptionContentRenderer && unlockedStructuredDescriptionContentRenderer !== null && unlockedStructuredDescriptionContentRenderer !== void 0 && unlockedStructuredDescriptionContentRenderer.expandableVideoDescriptionBodyRenderer) originalStructuredDescriptionContentRenderer.expandableVideoDescriptionBodyRenderer = unlockedStructuredDescriptionContentRenderer.expandableVideoDescriptionBodyRenderer;
      return nextResponse;
    }

    function getUnlockedPlayerResponse(videoId, reason) {
      var _playerResponse, _playerResponse$playa2;

      // Check if response is cached
      if (responseCache.videoId === videoId) return responseCache.playerResponse;
      setInnertubeConfigFromYtcfg();
      var playerResponse = useInnertubeEmbed();
      if (((_playerResponse = playerResponse) === null || _playerResponse === void 0 ? void 0 : (_playerResponse$playa2 = _playerResponse.playabilityStatus) === null || _playerResponse$playa2 === void 0 ? void 0 : _playerResponse$playa2.status) !== "OK") playerResponse = useProxy(); // Cache response for 10 seconds

      responseCache = {
        videoId: videoId,
        playerResponse: playerResponse
      };
      setTimeout(function () {
        responseCache = {};
      }, 10000);
      return playerResponse; // Strategy 1: Retrieve the video info by using a age-gate bypass for the innertube API
      // Source: https://github.com/yt-dlp/yt-dlp/issues/574#issuecomment-887171136

      function useInnertubeEmbed() {
        console.info("Simple-YouTube-Age-Restriction-Bypass: Trying Unlock Method #1 (Innertube Embed)");
        var payload = getInnertubeEmbedPayload(videoId);
        var xmlhttp = new XMLHttpRequest();
        xmlhttp.open("POST", "/youtubei/v1/player?key=".concat(INNERTUBE_CONFIG.INNERTUBE_API_KEY), false); // Synchronous!!!

        xmlhttp.send(JSON.stringify(payload));
        return nativeParse(xmlhttp.responseText);
      } // Strategy 2: Retrieve the video info from an account proxy server.
      // See https://github.com/zerodytrash/Simple-YouTube-Age-Restriction-Bypass/tree/main/account-proxy


      function useProxy() {
        console.info("Simple-YouTube-Age-Restriction-Bypass: Trying Unlock Method #2 (Account Proxy)");
        var xmlhttp = new XMLHttpRequest();
        xmlhttp.open("GET", ACCOUNT_PROXY_SERVER_HOST + "/getPlayer?videoId=".concat(encodeURIComponent(videoId), "&reason=").concat(encodeURIComponent(reason), "&clientName=").concat(INNERTUBE_CONFIG.INNERTUBE_CLIENT_NAME, "&clientVersion=").concat(INNERTUBE_CONFIG.INNERTUBE_CLIENT_VERSION, "&signatureTimestamp=").concat(INNERTUBE_CONFIG.STS), false); // Synchronous!!!

        xmlhttp.send(null);
        var playerResponse = nativeParse(xmlhttp.responseText);
        playerResponse.proxied = true;
        return playerResponse;
      }
    }

    function getUnlockedNextResponse(videoId, playlistId, playlistIndex) {
      setInnertubeConfigFromYtcfg(); // Retrieve the video info by using a age-gate bypass for the innertube API
      // Source: https://github.com/zerodytrash/Simple-YouTube-Age-Restriction-Bypass/issues/16#issuecomment-889232425

      console.info("Simple-YouTube-Age-Restriction-Bypass: Trying Sidebar Unlock Method (Innertube Embed)");
      var payload = getInnertubeEmbedPayload(videoId, playlistId, playlistIndex);
      var xmlhttp = new XMLHttpRequest();
      xmlhttp.open("POST", "/youtubei/v1/next?key=".concat(INNERTUBE_CONFIG.INNERTUBE_API_KEY), false); // Synchronous!!!

      xmlhttp.send(JSON.stringify(payload));
      return nativeParse(xmlhttp.responseText);
    }

    function getInnertubeEmbedPayload(videoId, playlistId, playlistIndex) {
      var _INNERTUBE_CONFIG$INN;

      var data = {
        context: {
          client: {
            clientName: INNERTUBE_CONFIG.INNERTUBE_CLIENT_NAME.replace('_EMBEDDED_PLAYER', ''),
            clientVersion: INNERTUBE_CONFIG.INNERTUBE_CLIENT_VERSION,
            clientScreen: "EMBED"
          },
          thirdParty: {
            embedUrl: "https://www.youtube.com/"
          }
        },
        playbackContext: {
          contentPlaybackContext: {
            signatureTimestamp: INNERTUBE_CONFIG.STS
          }
        },
        videoId: videoId,
        playlistId: playlistId,
        playlistIndex: playlistIndex
      }; // Append client info from INNERTUBE_CONTEXT

      if (_typeof((_INNERTUBE_CONFIG$INN = INNERTUBE_CONFIG.INNERTUBE_CONTEXT) === null || _INNERTUBE_CONFIG$INN === void 0 ? void 0 : _INNERTUBE_CONFIG$INN.client) === "object") {
        data.context.client = _objectSpread2(_objectSpread2({}, data.context.client), INNERTUBE_CONFIG.INNERTUBE_CONTEXT.client);
      }

      return data;
    } // to avoid version conflicts between client and server response, the current YouTube version config will be determined


    function setInnertubeConfigFromYtcfg() {
      if (!window.ytcfg) {
        console.warn("Simple-YouTube-Age-Restriction-Bypass: Unable to retrieve global YouTube configuration (window.ytcfg). Using old values...");
        return;
      }

      for (var key in INNERTUBE_CONFIG) {
        var _window$ytcfg$data_$k, _window$ytcfg$data_, _window$ytcfg$get, _window$ytcfg;

        var value = (_window$ytcfg$data_$k = (_window$ytcfg$data_ = window.ytcfg.data_) === null || _window$ytcfg$data_ === void 0 ? void 0 : _window$ytcfg$data_[key]) !== null && _window$ytcfg$data_$k !== void 0 ? _window$ytcfg$data_$k : (_window$ytcfg$get = (_window$ytcfg = window.ytcfg).get) === null || _window$ytcfg$get === void 0 ? void 0 : _window$ytcfg$get.call(_window$ytcfg, key);

        if (value !== undefined && value !== null) {
          INNERTUBE_CONFIG[key] = value;
        } else {
          console.warn("Simple-YouTube-Age-Restriction-Bypass: Unable to retrieve global YouTube configuration variable '".concat(key, "'. Using old value..."));
        }
      }
    } // Some extensions like AdBlock override the Object.defineProperty function to prevent a redefinition of the 'ytInitialPlayerResponse' variable by YouTube.
    // But we need to define a custom descriptor to that variable to intercept its value. This behavior causes a race condition depending on the execution order with this script :(
    // This function tries to restore the native Object.defineProperty function...


    function getNativeDefineProperty() {
      var _Object$definePropert, _tempFrame$contentWin, _tempFrame$contentWin2;

      // Check if the Object.defineProperty function is native (original)
      if (((_Object$definePropert = Object.defineProperty) === null || _Object$definePropert === void 0 ? void 0 : _Object$definePropert.toString().indexOf("[native code]")) > -1) {
        return Object.defineProperty;
      } // if the Object.defineProperty function is already overidden, try to restore the native function from another window...


      var tempFrame = createElement("iframe", {
        style: "display: none;"
      });
      document.documentElement.append(tempFrame);
      var nativeDefineProperty = tempFrame === null || tempFrame === void 0 ? void 0 : (_tempFrame$contentWin = tempFrame.contentWindow) === null || _tempFrame$contentWin === void 0 ? void 0 : (_tempFrame$contentWin2 = _tempFrame$contentWin.Object) === null || _tempFrame$contentWin2 === void 0 ? void 0 : _tempFrame$contentWin2.defineProperty;
      tempFrame.remove();

      if (nativeDefineProperty) {
        console.info("Simple-YouTube-Age-Restriction-Bypass: Overidden Object.defineProperty function successfully restored!");
        return nativeDefineProperty;
      } else {
        console.warn("Simple-YouTube-Age-Restriction-Bypass: Unable to restore the original Object.defineProperty function");
        return Object.defineProperty;
      }
    }

    function createElement(tagName, options) {
      var node = document.createElement(tagName);
      options && Object.assign(node, options);
      return node;
    }
  }; // Just a trick to get around the sandbox restrictions in Firefox / Greasemonkey
  // Greasemonkey => Inject code into the main window
  // Tampermonkey & Violentmonkey => Execute code directly


  if ((typeof GM_info === "undefined" ? "undefined" : _typeof(GM_info)) === "object" && GM_info.scriptHandler === "Greasemonkey" && !arguments[0]) {
    window.eval("(" + arguments.callee.toString() + ")(true);");
  } else {
    initUnlocker();
  }

}());
